Subject: bug#9123: bug/misbehaviour in vc-next action when stealing locks

From: Kourosh Neshatian <[email-masked]>
Date: Thu, 11 Aug 2011 18:43:22 +1200

Hi Glenn,

The problem has been experienced in versions 22.2.1 and 23.3.1 of
Emacs.

Steps to reproduce the error:

1. Alice (user name 'alice') runs Emacs with 'emacs -q --no-site-file'

2. Alice creates a text file in the directory, say 'document.tex', writes
some text in it and saves it.

3. She runs 'vc-next-action' (C-x v v) and chooses RCS as her
backend. This creates an RCS file 'RCS/document.tex,v'.

4. Alice checks out and locks the file again by 'vc-next-action' (C-x
v v) to add/make some changes in the document.

5. Meanwhile, Bob (user name 'bob') logs in.  He has access to the RCS
directory (usually via a symbolic link). He checks out document.tex
stealing  the lock (rcs -l ...). NOTE: you don't actually need to login as a
different user to simulate this step. Simply open
'RCS/document.tex,v' and change 'alice' (your user name) under 'locks'
section to
'bob'.

6. Now, Alice has finished editing her copy; she saves the file and
runs 'vc-next-action' (to check in). Emacs will ask her if she wants
to steal the lock, she says 'yes'. What happens is that Emacs
over-writes her local copy by the last version in the
repository. Alice's changes/edits are all gone and apparently she does
not have any means to recover!

Cheers,
Kourosh

On 11 August 2011 09:13, Glenn Morris <[email-masked]> wrote:
> albemarle wrote:
>
>> The following seems like a bug or msibehaviour to me.
>
> I'm having trouble reproducing this. Can you say which version of Emacs
> this is with? Can you give a complete description of the sequence of
> commands needed, starting from `emacs -q --no-site-file' when relevant?
>